#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include "Errors.h"
#include "Fct_Sys.h"
#include "Convert.h"
#include "TempGmurf.h"

short int	get_data(buf, nb_elt, pos, fd)
     short int	*buf;
     ssize_t	nb_elt; /* nombre d'elements dans buf */
     ssize_t	pos;
     int	fd;
{
  static ssize_t	debut = 0;

  if (buf == NULL)
    {
      debut = 0;
      return (0);
    }
  if (pos >= debut + nb_elt)
    {
      buf[0] = buf[nb_elt - 2];
      buf[1] = buf[nb_elt - 1];
      if (read(fd, &buf[2], (nb_elt - 2) * 2) == -1)
	{
#ifdef TEXT_MSG
	  printf("%s\n", BAD_READ);
#endif
	}
      debut += nb_elt - 2;
    }
  return (buf[(unsigned long) (pos - debut)]);
}

ssize_t put_data(val, buf, nb_elt, pos, fd)
     short int  val;
     short int	*buf;
     size_t	nb_elt; /* nombre d'elements dans buf */
     size_t	pos;
     int	fd;
{
  buf[pos] = val;
  if (pos == nb_elt - 1)
    return (write(fd, buf, nb_elt * 2));
  return (0);
}

/*
** set_rate: converti le fichier temporaire dont la structure de controle
**                  est passe en argument dans la frequance donnee
*/
int	set_rate(temp, old_rate, new_rate)
     t_tempgmurf	*temp;
     unsigned int	old_rate;
     unsigned int	new_rate;
{
  const	long	size_of_buf  = BUFFER_SIZE;
  const long	size_of_buf2 = BUFFER_SIZE * 2;

  int		temp_file2;
  size_t	cpt;
  ssize_t	target_size;
  ssize_t	prec;
  ssize_t	suiv;
  double	d;
  ssize_t	nb_wrote = 0;
  short int	new_val;
  short int	data_prec;
  short int	data_suiv;
  short int	buf[size_of_buf];
  short int	buf2[size_of_buf2];

  get_data(NULL, 0, 0, 0);
  temp_file2 = init_convert(temp->file);
  target_size = (ssize_t)(((double)give_file_size(temp->file)*((double) new_rate))/((double)old_rate));
  /* transtypage obligatoire car le resultat de la multiplication est trop grand!*/
  read(temp->file, buf, size_of_buf * 2);
  for (cpt = 0; cpt < (target_size / 2); cpt++)
    {  
      prec = cpt / 2;
      prec = (ssize_t) (((double) prec * (double) old_rate) / (double) new_rate);
      prec *= 2;
      prec += (cpt % 2);
      suiv = prec + 2;  
      data_prec = get_data(buf, size_of_buf, prec, temp->file); 
      data_suiv = get_data(buf, size_of_buf, suiv, temp->file); 
      d = ((((double) ((double) (cpt - (cpt % 2)) * ((double) old_rate))) / ((double) new_rate)) - ((double) prec)) + (cpt % 2);
      d /= 2;
      new_val = (short int) ((double) ((1 - (double) d) * data_prec) + (double) ((double) d * data_suiv));
      nb_wrote += put_data(new_val, buf2, size_of_buf2, cpt % size_of_buf2, temp_file2);
    } 
  if (nb_wrote < target_size) 
    write(temp_file2, buf2, target_size - nb_wrote);  
  close_convert(temp, temp_file2, temp_file);
  return (0);
}
